using System;
using System.Drawing;

using MindFusion.Diagramming;
using MindFusion.Diagramming.Layout;


namespace PdfExporter
{
	public partial class _Default : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
			{
				var diagram = diagramView.Diagram;
				diagram.DefaultShape = Shapes.Ellipse;
				diagram.ShapeNodeStyle.Brush = new MindFusion.Drawing.SolidBrush(Color.DarkViolet);

				var root = diagram.Factory.CreateShapeNode(0, 0, 10, 10);
				root.Tag = 0;
				CreateTree(diagram, root, 0);

				var layout = new TreeLayout();
				layout.Type = TreeLayoutType.Radial;
				layout.LevelDistance = 20;
				layout.Arrange(diagram);
			}
		}

		private void CreateTree(Diagram diagram, ShapeNode parent, int level)
		{
			if (level >= 2 + random.Next(2))
				return;

			for (int i = 0; i < random.Next(3) + 3; i++)
			{
				var next = diagram.Factory.CreateShapeNode(0, 0, 10, 10);
				next.Tag = level;
				diagram.Factory.CreateDiagramLink(parent, next);
				CreateTree(diagram, next, level + 1);
			}
		}

		protected void btnExportPdf_Click(object sender, EventArgs e)
		{
			MindFusion.Diagramming.Export.PdfExporter pdf =
				new MindFusion.Diagramming.Export.PdfExporter();

			string path = Server.MapPath(@"~\PDF\") + Session.SessionID + ".pdf";
			pdf.Export(diagramView.Diagram, path);

			pdfURL.Value = "PDF/" + Session.SessionID + ".pdf";
		}


		private Random random = new Random(DateTime.Now.Millisecond);
	}
}